<?php

// Global variable for table object
$case_notes = NULL;

//
// Table class for case_notes
//
class ccase_notes extends cTable {
	var $dbkey;
	var $start;
	var $end;
	var $weeknumber;
	var $counselor;
	var $dbkey_counselor;
	var $date;
	var $client;
	var $dbkey_client;
	var $outcome_note;
	var $outcome;
	var $client_met_outcome;
	var $how_objective;
	var $case_notes;
	var $create_date;
	var $update_date;
	var $updated_by;

	//
	// Table class constructor
	//
	function __construct() {
		global $Language;

		// Language object
		if (!isset($Language)) $Language = new cLanguage();
		$this->TableVar = 'case_notes';
		$this->TableName = 'case_notes';
		$this->TableType = 'TABLE';

		// Update Table
		$this->UpdateTable = "`case_notes`";
		$this->DBID = 'DB';
		$this->ExportAll = TRUE;
		$this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
		$this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
		$this->ExportPageSize = "a4"; // Page size (PDF only)
		$this->ExportExcelPageOrientation = ""; // Page orientation (PHPExcel only)
		$this->ExportExcelPageSize = ""; // Page size (PHPExcel only)
		$this->DetailAdd = FALSE; // Allow detail add
		$this->DetailEdit = FALSE; // Allow detail edit
		$this->DetailView = FALSE; // Allow detail view
		$this->ShowMultipleDetails = FALSE; // Show multiple details
		$this->GridAddRowCount = 1;
		$this->AllowAddDeleteRow = ew_AllowAddDeleteRow(); // Allow add/delete row
		$this->UserIDAllowSecurity = 0; // User ID Allow
		$this->BasicSearch = new cBasicSearch($this->TableVar);

		// dbkey
		$this->dbkey = new cField('case_notes', 'case_notes', 'x_dbkey', 'dbkey', '`dbkey`', '`dbkey`', 3, -1, FALSE, '`dbkey`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'NO');
		$this->dbkey->Sortable = TRUE; // Allow sort
		$this->dbkey->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey'] = &$this->dbkey;

		// start
		$this->start = new cField('case_notes', 'case_notes', 'x_start', 'start', 'adddate(case_notes.date,  INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY)', ew_CastDateFieldForLike('adddate(case_notes.date,  INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY)', 0, "DB"), 133, 0, FALSE, 'adddate(case_notes.date,  INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->start->FldIsCustom = TRUE; // Custom field
		$this->start->Sortable = FALSE; // Allow sort
		$this->start->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['start'] = &$this->start;

		// end
		$this->end = new cField('case_notes', 'case_notes', 'x_end', 'end', 'adddate(case_notes.date, INTERVAL 8-DAYOFWEEK(case_notes.date) DAY)', ew_CastDateFieldForLike('adddate(case_notes.date, INTERVAL 8-DAYOFWEEK(case_notes.date) DAY)', 0, "DB"), 133, 0, FALSE, 'adddate(case_notes.date, INTERVAL 8-DAYOFWEEK(case_notes.date) DAY)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->end->FldIsCustom = TRUE; // Custom field
		$this->end->Sortable = FALSE; // Allow sort
		$this->end->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['end'] = &$this->end;

		// weeknumber
		$this->weeknumber = new cField('case_notes', 'case_notes', 'x_weeknumber', 'weeknumber', 'WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY))', 'WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY))', 20, -1, FALSE, 'WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY))', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->weeknumber->FldIsCustom = TRUE; // Custom field
		$this->weeknumber->Sortable = TRUE; // Allow sort
		$this->weeknumber->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->weeknumber->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->weeknumber->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['weeknumber'] = &$this->weeknumber;

		// counselor
		$this->counselor = new cField('case_notes', 'case_notes', 'x_counselor', 'counselor', '(SELECT Concat(Concat(counselor.last, \' , \'), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)', '(SELECT Concat(Concat(counselor.last, \' , \'), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)', 200, -1, FALSE, '(SELECT Concat(Concat(counselor.last, \' , \'), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->counselor->FldIsCustom = TRUE; // Custom field
		$this->counselor->Sortable = TRUE; // Allow sort
		$this->counselor->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->counselor->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->fields['counselor'] = &$this->counselor;

		// dbkey_counselor
		$this->dbkey_counselor = new cField('case_notes', 'case_notes', 'x_dbkey_counselor', 'dbkey_counselor', '`dbkey_counselor`', '`dbkey_counselor`', 3, -1, FALSE, '`dbkey_counselor`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_counselor->Sortable = TRUE; // Allow sort
		$this->dbkey_counselor->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_counselor->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_counselor->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_counselor'] = &$this->dbkey_counselor;

		// date
		$this->date = new cField('case_notes', 'case_notes', 'x_date', 'date', '`date`', ew_CastDateFieldForLike('`date`', 0, "DB"), 133, 0, FALSE, '`date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->date->Sortable = FALSE; // Allow sort
		$this->date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['date'] = &$this->date;

		// client
		$this->client = new cField('case_notes', 'case_notes', 'x_client', 'client', '(SELECT Concat(Concat(client.last, \' , \'), client.first) FROM client WHERE client.dbkey = case_notes.dbkey_client)', '(SELECT Concat(Concat(client.last, \' , \'), client.first) FROM client WHERE client.dbkey = case_notes.dbkey_client)', 200, -1, FALSE, '(SELECT Concat(Concat(client.last, \' , \'), client.first) FROM client WHERE client.dbkey = case_notes.dbkey_client)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->client->FldIsCustom = TRUE; // Custom field
		$this->client->Sortable = TRUE; // Allow sort
		$this->fields['client'] = &$this->client;

		// dbkey_client
		$this->dbkey_client = new cField('case_notes', 'case_notes', 'x_dbkey_client', 'dbkey_client', '`dbkey_client`', '`dbkey_client`', 3, -1, FALSE, '`dbkey_client`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->dbkey_client->Sortable = TRUE; // Allow sort
		$this->dbkey_client->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->dbkey_client->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->dbkey_client->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['dbkey_client'] = &$this->dbkey_client;

		// outcome_note
		$this->outcome_note = new cField('case_notes', 'case_notes', 'x_outcome_note', 'outcome_note', '`outcome_note`', '`outcome_note`', 201, -1, FALSE, '`outcome_note`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->outcome_note->Sortable = TRUE; // Allow sort
		$this->fields['outcome_note'] = &$this->outcome_note;

		// outcome
		$this->outcome = new cField('case_notes', 'case_notes', 'x_outcome', 'outcome', '(select trim(outcome_note) from client_outcome where client_outcome.dbkey_client = case_notes.dbkey_client)', '(select trim(outcome_note) from client_outcome where client_outcome.dbkey_client = case_notes.dbkey_client)', 201, -1, FALSE, '(select trim(outcome_note) from client_outcome where client_outcome.dbkey_client = case_notes.dbkey_client)', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->outcome->FldIsCustom = TRUE; // Custom field
		$this->outcome->Sortable = FALSE; // Allow sort
		$this->fields['outcome'] = &$this->outcome;

		// client_met_outcome
		$this->client_met_outcome = new cField('case_notes', 'case_notes', 'x_client_met_outcome', 'client_met_outcome', '`client_met_outcome`', '`client_met_outcome`', 16, -1, FALSE, '`client_met_outcome`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'SELECT');
		$this->client_met_outcome->Sortable = TRUE; // Allow sort
		$this->client_met_outcome->UsePleaseSelect = TRUE; // Use PleaseSelect by default
		$this->client_met_outcome->PleaseSelectText = $Language->Phrase("PleaseSelect"); // PleaseSelect text
		$this->client_met_outcome->OptionCount = 3;
		$this->client_met_outcome->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['client_met_outcome'] = &$this->client_met_outcome;

		// how_objective
		$this->how_objective = new cField('case_notes', 'case_notes', 'x_how_objective', 'how_objective', '`how_objective`', '`how_objective`', 201, -1, FALSE, '`how_objective`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->how_objective->Sortable = TRUE; // Allow sort
		$this->fields['how_objective'] = &$this->how_objective;

		// case_notes
		$this->case_notes = new cField('case_notes', 'case_notes', 'x_case_notes', 'case_notes', '`case_notes`', '`case_notes`', 201, -1, FALSE, '`case_notes`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXTAREA');
		$this->case_notes->Sortable = TRUE; // Allow sort
		$this->fields['case_notes'] = &$this->case_notes;

		// create_date
		$this->create_date = new cField('case_notes', 'case_notes', 'x_create_date', 'create_date', '`create_date`', ew_CastDateFieldForLike('`create_date`', 0, "DB"), 135, 0, FALSE, '`create_date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->create_date->Sortable = FALSE; // Allow sort
		$this->create_date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['create_date'] = &$this->create_date;

		// update_date
		$this->update_date = new cField('case_notes', 'case_notes', 'x_update_date', 'update_date', '`update_date`', ew_CastDateFieldForLike('`update_date`', 0, "DB"), 135, 0, FALSE, '`update_date`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->update_date->Sortable = FALSE; // Allow sort
		$this->update_date->FldDefaultErrMsg = str_replace("%s", $GLOBALS["EW_DATE_FORMAT"], $Language->Phrase("IncorrectDate"));
		$this->fields['update_date'] = &$this->update_date;

		// updated_by
		$this->updated_by = new cField('case_notes', 'case_notes', 'x_updated_by', 'updated_by', '`updated_by`', '`updated_by`', 3, -1, FALSE, '`updated_by`', FALSE, FALSE, FALSE, 'FORMATTED TEXT', 'TEXT');
		$this->updated_by->Sortable = FALSE; // Allow sort
		$this->updated_by->FldDefaultErrMsg = $Language->Phrase("IncorrectInteger");
		$this->fields['updated_by'] = &$this->updated_by;
	}

	// Set Field Visibility
	function SetFieldVisibility($fldparm) {
		global $Security;
		return $this->$fldparm->Visible; // Returns original value
	}

	// Single column sort
	function UpdateSort(&$ofld) {
		if ($this->CurrentOrder == $ofld->FldName) {
			$sSortField = $ofld->FldExpression;
			$sLastSort = $ofld->getSort();
			if ($this->CurrentOrderType == "ASC" || $this->CurrentOrderType == "DESC") {
				$sThisSort = $this->CurrentOrderType;
			} else {
				$sThisSort = ($sLastSort == "ASC") ? "DESC" : "ASC";
			}
			$ofld->setSort($sThisSort);
			$this->setSessionOrderBy($sSortField . " " . $sThisSort); // Save to Session
		} else {
			$ofld->setSort("");
		}
	}

	// Table level SQL
	var $_SqlFrom = "";

	function getSqlFrom() { // From
		return ($this->_SqlFrom <> "") ? $this->_SqlFrom : "`case_notes`";
	}

	function SqlFrom() { // For backward compatibility
		return $this->getSqlFrom();
	}

	function setSqlFrom($v) {
		$this->_SqlFrom = $v;
	}
	var $_SqlSelect = "";

	function getSqlSelect() { // Select
		return ($this->_SqlSelect <> "") ? $this->_SqlSelect : "SELECT *, adddate(case_notes.date,  INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY) AS `start`, adddate(case_notes.date, INTERVAL 8-DAYOFWEEK(case_notes.date) DAY) AS `end`, WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY)) AS `weeknumber`, (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `counselor`, (SELECT Concat(Concat(client.last, ' , '), client.first) FROM client WHERE client.dbkey = case_notes.dbkey_client) AS `client`, (select trim(outcome_note) from client_outcome where client_outcome.dbkey_client = case_notes.dbkey_client) AS `outcome` FROM " . $this->getSqlFrom();
	}

	function SqlSelect() { // For backward compatibility
		return $this->getSqlSelect();
	}

	function setSqlSelect($v) {
		$this->_SqlSelect = $v;
	}
	var $_SqlWhere = "";

	function getSqlWhere() { // Where
		$sWhere = ($this->_SqlWhere <> "") ? $this->_SqlWhere : "";
		$this->TableFilter = "";
		ew_AddFilter($sWhere, $this->TableFilter);
		return $sWhere;
	}

	function SqlWhere() { // For backward compatibility
		return $this->getSqlWhere();
	}

	function setSqlWhere($v) {
		$this->_SqlWhere = $v;
	}
	var $_SqlGroupBy = "";

	function getSqlGroupBy() { // Group By
		return ($this->_SqlGroupBy <> "") ? $this->_SqlGroupBy : "";
	}

	function SqlGroupBy() { // For backward compatibility
		return $this->getSqlGroupBy();
	}

	function setSqlGroupBy($v) {
		$this->_SqlGroupBy = $v;
	}
	var $_SqlHaving = "";

	function getSqlHaving() { // Having
		return ($this->_SqlHaving <> "") ? $this->_SqlHaving : "";
	}

	function SqlHaving() { // For backward compatibility
		return $this->getSqlHaving();
	}

	function setSqlHaving($v) {
		$this->_SqlHaving = $v;
	}
	var $_SqlOrderBy = "";

	function getSqlOrderBy() { // Order By
		return ($this->_SqlOrderBy <> "") ? $this->_SqlOrderBy : "`create_date` DESC";
	}

	function SqlOrderBy() { // For backward compatibility
		return $this->getSqlOrderBy();
	}

	function setSqlOrderBy($v) {
		$this->_SqlOrderBy = $v;
	}

	// Apply User ID filters
	function ApplyUserIDFilters($sFilter) {
		global $Security;

		// Add User ID filter
		if ($Security->CurrentUserID() <> "" && !$Security->IsAdmin()) { // Non system admin
			$sFilter = $this->AddUserIDFilter($sFilter);
		}
		return $sFilter;
	}

	// Check if User ID security allows view all
	function UserIDAllow($id = "") {
		$allow = $this->UserIDAllowSecurity;
		switch ($id) {
			case "add":
			case "copy":
			case "gridadd":
			case "register":
			case "addopt":
				return (($allow & 1) == 1);
			case "edit":
			case "gridedit":
			case "update":
			case "changepwd":
			case "forgotpwd":
				return (($allow & 4) == 4);
			case "delete":
				return (($allow & 2) == 2);
			case "view":
				return (($allow & 32) == 32);
			case "search":
				return (($allow & 64) == 64);
			default:
				return (($allow & 8) == 8);
		}
	}

	// Get SQL
	function GetSQL($where, $orderby) {
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$where, $orderby);
	}

	// Table SQL
	function SQL() {
		$sFilter = $this->CurrentFilter;
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(),
			$this->getSqlGroupBy(), $this->getSqlHaving(), $this->getSqlOrderBy(),
			$sFilter, $sSort);
	}

	// Table SQL with List page filter
	function SelectSQL() {
		$sFilter = $this->getSessionWhere();
		ew_AddFilter($sFilter, $this->CurrentFilter);
		$sFilter = $this->ApplyUserIDFilters($sFilter);
		$this->Recordset_Selecting($sFilter);
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql($this->getSqlSelect(), $this->getSqlWhere(), $this->getSqlGroupBy(),
			$this->getSqlHaving(), $this->getSqlOrderBy(), $sFilter, $sSort);
	}

	// Get ORDER BY clause
	function GetOrderBy() {
		$sSort = $this->getSessionOrderBy();
		return ew_BuildSelectSql("", "", "", "", $this->getSqlOrderBy(), "", $sSort);
	}

	// Try to get record count
	function TryGetRecordCount($sSql) {
		$cnt = -1;
		if (($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') && preg_match("/^SELECT \* FROM/i", $sSql)) {
			$sSql = "SELECT COUNT(*) FROM" . preg_replace('/^SELECT\s([\s\S]+)?\*\sFROM/i', "", $sSql);
			$sOrderBy = $this->GetOrderBy();
			if (substr($sSql, strlen($sOrderBy) * -1) == $sOrderBy)
				$sSql = substr($sSql, 0, strlen($sSql) - strlen($sOrderBy)); // Remove ORDER BY clause
		} else {
			$sSql = "SELECT COUNT(*) FROM (" . $sSql . ") EW_COUNT_TABLE";
		}
		$conn = &$this->Connection();
		if ($rs = $conn->Execute($sSql)) {
			if (!$rs->EOF && $rs->FieldCount() > 0) {
				$cnt = $rs->fields[0];
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// Get record count based on filter (for detail record count in master table pages)
	function LoadRecordCount($sFilter) {
		$origFilter = $this->CurrentFilter;
		$this->CurrentFilter = $sFilter;
		$this->Recordset_Selecting($this->CurrentFilter);

		//$sSql = $this->SQL();
		$sSql = $this->GetSQL($this->CurrentFilter, "");
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			if ($rs = $this->LoadRs($this->CurrentFilter)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		$this->CurrentFilter = $origFilter;
		return intval($cnt);
	}

	// Get record count (for current List page)
	function SelectRecordCount() {
		$sSql = $this->SelectSQL();
		$cnt = $this->TryGetRecordCount($sSql);
		if ($cnt == -1) {
			$conn = &$this->Connection();
			if ($rs = $conn->Execute($sSql)) {
				$cnt = $rs->RecordCount();
				$rs->Close();
			}
		}
		return intval($cnt);
	}

	// INSERT statement
	function InsertSQL(&$rs) {
		$names = "";
		$values = "";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$names .= $this->fields[$name]->FldExpression . ",";
			$values .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($names, -1) == ",")
			$names = substr($names, 0, -1);
		while (substr($values, -1) == ",")
			$values = substr($values, 0, -1);
		return "INSERT INTO " . $this->UpdateTable . " ($names) VALUES ($values)";
	}

	// Insert
	function Insert(&$rs) {
		$conn = &$this->Connection();
		return $conn->Execute($this->InsertSQL($rs));
	}

	// UPDATE statement
	function UpdateSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "UPDATE " . $this->UpdateTable . " SET ";
		foreach ($rs as $name => $value) {
			if (!isset($this->fields[$name]) || $this->fields[$name]->FldIsCustom)
				continue;
			$sql .= $this->fields[$name]->FldExpression . "=";
			$sql .= ew_QuotedValue($value, $this->fields[$name]->FldDataType, $this->DBID) . ",";
		}
		while (substr($sql, -1) == ",")
			$sql = substr($sql, 0, -1);
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		ew_AddFilter($filter, $where);
		if ($filter <> "")	$sql .= " WHERE " . $filter;
		return $sql;
	}

	// Update
	function Update(&$rs, $where = "", $rsold = NULL, $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->UpdateSQL($rs, $where, $curfilter));
	}

	// DELETE statement
	function DeleteSQL(&$rs, $where = "", $curfilter = TRUE) {
		$sql = "DELETE FROM " . $this->UpdateTable . " WHERE ";
		if (is_array($where))
			$where = $this->ArrayToFilter($where);
		if ($rs) {
			if (array_key_exists('dbkey', $rs))
				ew_AddFilter($where, ew_QuotedName('dbkey', $this->DBID) . '=' . ew_QuotedValue($rs['dbkey'], $this->dbkey->FldDataType, $this->DBID));
		}
		$filter = ($curfilter) ? $this->CurrentFilter : "";
		ew_AddFilter($filter, $where);
		if ($filter <> "")
			$sql .= $filter;
		else
			$sql .= "0=1"; // Avoid delete
		return $sql;
	}

	// Delete
	function Delete(&$rs, $where = "", $curfilter = TRUE) {
		$conn = &$this->Connection();
		return $conn->Execute($this->DeleteSQL($rs, $where, $curfilter));
	}

	// Key filter WHERE clause
	function SqlKeyFilter() {
		return "`dbkey` = @dbkey@";
	}

	// Key filter
	function KeyFilter() {
		$sKeyFilter = $this->SqlKeyFilter();
		if (!is_numeric($this->dbkey->CurrentValue))
			$sKeyFilter = "0=1"; // Invalid key
		$sKeyFilter = str_replace("@dbkey@", ew_AdjustSql($this->dbkey->CurrentValue, $this->DBID), $sKeyFilter); // Replace key value
		return $sKeyFilter;
	}

	// Return page URL
	function getReturnUrl() {
		$name = EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL;

		// Get referer URL automatically
		if (ew_ServerVar("HTTP_REFERER") <> "" && ew_ReferPage() <> ew_CurrentPage() && ew_ReferPage() <> "login.php") // Referer not same page or login page
			$_SESSION[$name] = ew_ServerVar("HTTP_REFERER"); // Save to Session
		if (@$_SESSION[$name] <> "") {
			return $_SESSION[$name];
		} else {
			return "case_noteslist.php";
		}
	}

	function setReturnUrl($v) {
		$_SESSION[EW_PROJECT_NAME . "_" . $this->TableVar . "_" . EW_TABLE_RETURN_URL] = $v;
	}

	// List URL
	function GetListUrl() {
		return "case_noteslist.php";
	}

	// View URL
	function GetViewUrl($parm = "") {
		if ($parm <> "")
			$url = $this->KeyUrl("case_notesview.php", $this->UrlParm($parm));
		else
			$url = $this->KeyUrl("case_notesview.php", $this->UrlParm(EW_TABLE_SHOW_DETAIL . "="));
		return $this->AddMasterUrl($url);
	}

	// Add URL
	function GetAddUrl($parm = "") {
		if ($parm <> "")
			$url = "case_notesadd.php?" . $this->UrlParm($parm);
		else
			$url = "case_notesadd.php";
		return $this->AddMasterUrl($url);
	}

	// Edit URL
	function GetEditUrl($parm = "") {
		$url = $this->KeyUrl("case_notesedit.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline edit URL
	function GetInlineEditUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=edit"));
		return $this->AddMasterUrl($url);
	}

	// Copy URL
	function GetCopyUrl($parm = "") {
		$url = $this->KeyUrl("case_notesadd.php", $this->UrlParm($parm));
		return $this->AddMasterUrl($url);
	}

	// Inline copy URL
	function GetInlineCopyUrl() {
		$url = $this->KeyUrl(ew_CurrentPage(), $this->UrlParm("a=copy"));
		return $this->AddMasterUrl($url);
	}

	// Delete URL
	function GetDeleteUrl() {
		return $this->KeyUrl("case_notesdelete.php", $this->UrlParm());
	}

	// Add master url
	function AddMasterUrl($url) {
		return $url;
	}

	function KeyToJson() {
		$json = "";
		$json .= "dbkey:" . ew_VarToJson($this->dbkey->CurrentValue, "number", "'");
		return "{" . $json . "}";
	}

	// Add key value to URL
	function KeyUrl($url, $parm = "") {
		$sUrl = $url . "?";
		if ($parm <> "") $sUrl .= $parm . "&";
		if (!is_null($this->dbkey->CurrentValue)) {
			$sUrl .= "dbkey=" . urlencode($this->dbkey->CurrentValue);
		} else {
			return "javascript:ew_Alert(ewLanguage.Phrase('InvalidRecord'));";
		}
		return $sUrl;
	}

	// Sort URL
	function SortUrl(&$fld) {
		if ($this->CurrentAction <> "" || $this->Export <> "" ||
			in_array($fld->FldType, array(128, 204, 205))) { // Unsortable data type
				return "";
		} elseif ($fld->Sortable) {
			$sUrlParm = $this->UrlParm("order=" . urlencode($fld->FldName) . "&amp;ordertype=" . $fld->ReverseSort());
			return $this->AddMasterUrl(ew_CurrentPage() . "?" . $sUrlParm);
		} else {
			return "";
		}
	}

	// Get record keys from $_POST/$_GET/$_SESSION
	function GetRecordKeys() {
		global $EW_COMPOSITE_KEY_SEPARATOR;
		$arKeys = array();
		$arKey = array();
		if (isset($_POST["key_m"])) {
			$arKeys = ew_StripSlashes($_POST["key_m"]);
			$cnt = count($arKeys);
		} elseif (isset($_GET["key_m"])) {
			$arKeys = ew_StripSlashes($_GET["key_m"]);
			$cnt = count($arKeys);
		} elseif (!empty($_GET) || !empty($_POST)) {
			$isPost = ew_IsHttpPost();
			if ($isPost && isset($_POST["dbkey"]))
				$arKeys[] = ew_StripSlashes($_POST["dbkey"]);
			elseif (isset($_GET["dbkey"]))
				$arKeys[] = ew_StripSlashes($_GET["dbkey"]);
			else
				$arKeys = NULL; // Do not setup

			//return $arKeys; // Do not return yet, so the values will also be checked by the following code
		}

		// Check keys
		$ar = array();
		if (is_array($arKeys)) {
			foreach ($arKeys as $key) {
				if (!is_numeric($key))
					continue;
				$ar[] = $key;
			}
		}
		return $ar;
	}

	// Get key filter
	function GetKeyFilter() {
		$arKeys = $this->GetRecordKeys();
		$sKeyFilter = "";
		foreach ($arKeys as $key) {
			if ($sKeyFilter <> "") $sKeyFilter .= " OR ";
			$this->dbkey->CurrentValue = $key;
			$sKeyFilter .= "(" . $this->KeyFilter() . ")";
		}
		return $sKeyFilter;
	}

	// Load rows based on filter
	function &LoadRs($sFilter) {

		// Set up filter (SQL WHERE clause) and get return SQL
		//$this->CurrentFilter = $sFilter;
		//$sSql = $this->SQL();

		$sSql = $this->GetSQL($sFilter, "");
		$conn = &$this->Connection();
		$rs = $conn->Execute($sSql);
		return $rs;
	}

	// Load row values from recordset
	function LoadListRowValues(&$rs) {
		$this->dbkey->setDbValue($rs->fields('dbkey'));
		$this->start->setDbValue($rs->fields('start'));
		$this->end->setDbValue($rs->fields('end'));
		$this->weeknumber->setDbValue($rs->fields('weeknumber'));
		$this->counselor->setDbValue($rs->fields('counselor'));
		$this->dbkey_counselor->setDbValue($rs->fields('dbkey_counselor'));
		$this->date->setDbValue($rs->fields('date'));
		$this->client->setDbValue($rs->fields('client'));
		$this->dbkey_client->setDbValue($rs->fields('dbkey_client'));
		$this->outcome_note->setDbValue($rs->fields('outcome_note'));
		$this->outcome->setDbValue($rs->fields('outcome'));
		$this->client_met_outcome->setDbValue($rs->fields('client_met_outcome'));
		$this->how_objective->setDbValue($rs->fields('how_objective'));
		$this->case_notes->setDbValue($rs->fields('case_notes'));
		$this->create_date->setDbValue($rs->fields('create_date'));
		$this->update_date->setDbValue($rs->fields('update_date'));
		$this->updated_by->setDbValue($rs->fields('updated_by'));
	}

	// Render list row values
	function RenderListRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

   // Common render codes
		// dbkey

		$this->dbkey->CellCssStyle = "white-space: nowrap;";

		// start
		$this->start->CellCssStyle = "white-space: nowrap;";

		// end
		$this->end->CellCssStyle = "white-space: nowrap;";

		// weeknumber
		// counselor
		// dbkey_counselor

		$this->dbkey_counselor->CellCssStyle = "white-space: nowrap;";

		// date
		$this->date->CellCssStyle = "white-space: nowrap;";

		// client
		// dbkey_client

		$this->dbkey_client->CellCssStyle = "white-space: nowrap;";

		// outcome_note
		// outcome

		$this->outcome->CellCssStyle = "white-space: nowrap;";

		// client_met_outcome
		// how_objective
		// case_notes
		// create_date

		$this->create_date->CellCssStyle = "white-space: nowrap;";

		// update_date
		$this->update_date->CellCssStyle = "white-space: nowrap;";

		// updated_by
		$this->updated_by->CellCssStyle = "white-space: nowrap;";

		// dbkey
		$this->dbkey->ViewValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// start
		$this->start->ViewValue = $this->start->CurrentValue;
		$this->start->ViewValue = ew_FormatDateTime($this->start->ViewValue, 0);
		$this->start->ViewCustomAttributes = "";

		// end
		$this->end->ViewValue = $this->end->CurrentValue;
		$this->end->ViewValue = ew_FormatDateTime($this->end->ViewValue, 0);
		$this->end->ViewCustomAttributes = "";

		// weeknumber
		if (strval($this->weeknumber->CurrentValue) <> "") {
			$sFilterWrk = "WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY))" . ew_SearchString("=", $this->weeknumber->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT DISTINCT WEEKOFYEAR(adddate(case_notes.date, INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY)), adddate(case_notes.date,  INTERVAL 2 - DAYOFWEEK(case_notes.date) DAY) AS `DispFld`, adddate(case_notes.date, INTERVAL 8-DAYOFWEEK(case_notes.date) DAY) AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->weeknumber->LookupFilters = array("df1" => "0", "df2" => "0");
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->weeknumber, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = ew_FormatDateTime($rswrk->fields('DispFld'), 0);
				$arwrk[2] = ew_FormatDateTime($rswrk->fields('Disp2Fld'), 0);
				$this->weeknumber->ViewValue = $this->weeknumber->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->weeknumber->ViewValue = $this->weeknumber->CurrentValue;
			}
		} else {
			$this->weeknumber->ViewValue = NULL;
		}
		$this->weeknumber->ViewCustomAttributes = "";

		// counselor
		if (strval($this->counselor->CurrentValue) <> "") {
			$sFilterWrk = "(SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor)" . ew_SearchString("=", $this->counselor->CurrentValue, EW_DATATYPE_STRING, "");
		$sSqlWrk = "SELECT DISTINCT (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor), (SELECT Concat(Concat(counselor.last, ' , '), counselor.first) FROM counselor WHERE counselor.dbkey = case_notes.dbkey_counselor) AS `DispFld`, '' AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `case_notes`";
		$sWhereWrk = "";
		$this->counselor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$this->counselor->ViewValue = $this->counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->counselor->ViewValue = $this->counselor->CurrentValue;
			}
		} else {
			$this->counselor->ViewValue = NULL;
		}
		$this->counselor->ViewCustomAttributes = "";

		// dbkey_counselor
		if (strval($this->dbkey_counselor->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_counselor->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->dbkey_counselor->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_counselor, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_counselor->ViewValue = $this->dbkey_counselor->CurrentValue;
			}
		} else {
			$this->dbkey_counselor->ViewValue = NULL;
		}
		$this->dbkey_counselor->ViewCustomAttributes = "";

		// date
		$this->date->ViewValue = $this->date->CurrentValue;
		$this->date->ViewValue = ew_FormatDateTime($this->date->ViewValue, 0);
		$this->date->ViewCustomAttributes = "";

		// client
		$this->client->ViewValue = $this->client->CurrentValue;
		$this->client->ViewCustomAttributes = "";

		// dbkey_client
		if (strval($this->dbkey_client->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->dbkey_client->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `client`";
		$sWhereWrk = "";
		$this->dbkey_client->LookupFilters = array();
		$lookuptblfilter = "`active` = 1";
		ew_AddFilter($sWhereWrk, $lookuptblfilter);
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->dbkey_client, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
		$sSqlWrk .= " ORDER BY `last`";
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->dbkey_client->ViewValue = $this->dbkey_client->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->dbkey_client->ViewValue = $this->dbkey_client->CurrentValue;
			}
		} else {
			$this->dbkey_client->ViewValue = NULL;
		}
		$this->dbkey_client->ViewCustomAttributes = "";

		// outcome_note
		$this->outcome_note->ViewValue = $this->outcome_note->CurrentValue;
		$this->outcome_note->ViewCustomAttributes = "";

		// outcome
		$this->outcome->ViewValue = $this->outcome->CurrentValue;
		$this->outcome->ViewCustomAttributes = "";

		// client_met_outcome
		if (strval($this->client_met_outcome->CurrentValue) <> "") {
			$this->client_met_outcome->ViewValue = $this->client_met_outcome->OptionCaption($this->client_met_outcome->CurrentValue);
		} else {
			$this->client_met_outcome->ViewValue = NULL;
		}
		$this->client_met_outcome->ViewCustomAttributes = "";

		// how_objective
		$this->how_objective->ViewValue = $this->how_objective->CurrentValue;
		$this->how_objective->ViewCustomAttributes = "";

		// case_notes
		$this->case_notes->ViewValue = $this->case_notes->CurrentValue;
		$this->case_notes->ViewCustomAttributes = "";

		// create_date
		$this->create_date->ViewValue = $this->create_date->CurrentValue;
		$this->create_date->ViewValue = ew_FormatDateTime($this->create_date->ViewValue, 0);
		$this->create_date->ViewCustomAttributes = "";

		// update_date
		$this->update_date->ViewValue = $this->update_date->CurrentValue;
		$this->update_date->ViewValue = ew_FormatDateTime($this->update_date->ViewValue, 0);
		$this->update_date->ViewCustomAttributes = "";

		// updated_by
		$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
		if (strval($this->updated_by->CurrentValue) <> "") {
			$sFilterWrk = "`dbkey`" . ew_SearchString("=", $this->updated_by->CurrentValue, EW_DATATYPE_NUMBER, "");
		$sSqlWrk = "SELECT `dbkey`, `last` AS `DispFld`, `first` AS `Disp2Fld`, '' AS `Disp3Fld`, '' AS `Disp4Fld` FROM `counselor`";
		$sWhereWrk = "";
		$this->updated_by->LookupFilters = array();
		ew_AddFilter($sWhereWrk, $sFilterWrk);
		$this->Lookup_Selecting($this->updated_by, $sWhereWrk); // Call Lookup selecting
		if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = Conn()->Execute($sSqlWrk);
			if ($rswrk && !$rswrk->EOF) { // Lookup values found
				$arwrk = array();
				$arwrk[1] = $rswrk->fields('DispFld');
				$arwrk[2] = $rswrk->fields('Disp2Fld');
				$this->updated_by->ViewValue = $this->updated_by->DisplayValue($arwrk);
				$rswrk->Close();
			} else {
				$this->updated_by->ViewValue = $this->updated_by->CurrentValue;
			}
		} else {
			$this->updated_by->ViewValue = NULL;
		}
		$this->updated_by->ViewCustomAttributes = "";

		// dbkey
		$this->dbkey->LinkCustomAttributes = "";
		$this->dbkey->HrefValue = "";
		$this->dbkey->TooltipValue = "";

		// start
		$this->start->LinkCustomAttributes = "";
		$this->start->HrefValue = "";
		$this->start->TooltipValue = "";

		// end
		$this->end->LinkCustomAttributes = "";
		$this->end->HrefValue = "";
		$this->end->TooltipValue = "";

		// weeknumber
		$this->weeknumber->LinkCustomAttributes = "";
		$this->weeknumber->HrefValue = "";
		$this->weeknumber->TooltipValue = "";

		// counselor
		$this->counselor->LinkCustomAttributes = "";
		$this->counselor->HrefValue = "";
		$this->counselor->TooltipValue = "";

		// dbkey_counselor
		$this->dbkey_counselor->LinkCustomAttributes = "";
		$this->dbkey_counselor->HrefValue = "";
		$this->dbkey_counselor->TooltipValue = "";

		// date
		$this->date->LinkCustomAttributes = "";
		$this->date->HrefValue = "";
		$this->date->TooltipValue = "";

		// client
		$this->client->LinkCustomAttributes = "";
		$this->client->HrefValue = "";
		$this->client->TooltipValue = "";

		// dbkey_client
		$this->dbkey_client->LinkCustomAttributes = "";
		$this->dbkey_client->HrefValue = "";
		$this->dbkey_client->TooltipValue = "";

		// outcome_note
		$this->outcome_note->LinkCustomAttributes = "";
		$this->outcome_note->HrefValue = "";
		$this->outcome_note->TooltipValue = "";

		// outcome
		$this->outcome->LinkCustomAttributes = "";
		$this->outcome->HrefValue = "";
		$this->outcome->TooltipValue = "";

		// client_met_outcome
		$this->client_met_outcome->LinkCustomAttributes = "";
		$this->client_met_outcome->HrefValue = "";
		$this->client_met_outcome->TooltipValue = "";

		// how_objective
		$this->how_objective->LinkCustomAttributes = "";
		$this->how_objective->HrefValue = "";
		$this->how_objective->TooltipValue = "";

		// case_notes
		$this->case_notes->LinkCustomAttributes = "";
		$this->case_notes->HrefValue = "";
		$this->case_notes->TooltipValue = "";

		// create_date
		$this->create_date->LinkCustomAttributes = "";
		$this->create_date->HrefValue = "";
		$this->create_date->TooltipValue = "";

		// update_date
		$this->update_date->LinkCustomAttributes = "";
		$this->update_date->HrefValue = "";
		$this->update_date->TooltipValue = "";

		// updated_by
		$this->updated_by->LinkCustomAttributes = "";
		$this->updated_by->HrefValue = "";
		$this->updated_by->TooltipValue = "";

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Render edit row values
	function RenderEditRow() {
		global $Security, $gsLanguage, $Language;

		// Call Row Rendering event
		$this->Row_Rendering();

		// dbkey
		$this->dbkey->EditAttrs["class"] = "form-control";
		$this->dbkey->EditCustomAttributes = "";
		$this->dbkey->EditValue = $this->dbkey->CurrentValue;
		$this->dbkey->ViewCustomAttributes = "";

		// start
		$this->start->EditAttrs["class"] = "form-control";
		$this->start->EditCustomAttributes = "";
		$this->start->EditValue = ew_FormatDateTime($this->start->CurrentValue, 8);
		$this->start->PlaceHolder = ew_RemoveHtml($this->start->FldCaption());

		// end
		$this->end->EditAttrs["class"] = "form-control";
		$this->end->EditCustomAttributes = "";
		$this->end->EditValue = ew_FormatDateTime($this->end->CurrentValue, 8);
		$this->end->PlaceHolder = ew_RemoveHtml($this->end->FldCaption());

		// weeknumber
		$this->weeknumber->EditAttrs["class"] = "form-control";
		$this->weeknumber->EditCustomAttributes = "";

		// counselor
		$this->counselor->EditAttrs["class"] = "form-control";
		$this->counselor->EditCustomAttributes = "";

		// dbkey_counselor
		$this->dbkey_counselor->EditAttrs["class"] = "form-control";
		$this->dbkey_counselor->EditCustomAttributes = "";
		if (!$Security->IsAdmin() && $Security->IsLoggedIn() && !$this->UserIDAllow("info")) { // Non system admin
		} else {
		}

		// date
		$this->date->EditAttrs["class"] = "form-control";
		$this->date->EditCustomAttributes = "";
		$this->date->EditValue = ew_FormatDateTime($this->date->CurrentValue, 8);
		$this->date->PlaceHolder = ew_RemoveHtml($this->date->FldCaption());

		// client
		$this->client->EditAttrs["class"] = "form-control";
		$this->client->EditCustomAttributes = "";
		$this->client->EditValue = $this->client->CurrentValue;
		$this->client->PlaceHolder = ew_RemoveHtml($this->client->FldCaption());

		// dbkey_client
		$this->dbkey_client->EditAttrs["class"] = "form-control";
		$this->dbkey_client->EditCustomAttributes = "";

		// outcome_note
		$this->outcome_note->EditAttrs["class"] = "form-control";
		$this->outcome_note->EditCustomAttributes = "";
		$this->outcome_note->EditValue = $this->outcome_note->CurrentValue;
		$this->outcome_note->ViewCustomAttributes = "";

		// outcome
		$this->outcome->EditAttrs["class"] = "form-control";
		$this->outcome->EditCustomAttributes = "";
		$this->outcome->EditValue = $this->outcome->CurrentValue;
		$this->outcome->PlaceHolder = ew_RemoveHtml($this->outcome->FldCaption());

		// client_met_outcome
		$this->client_met_outcome->EditCustomAttributes = "";
		$this->client_met_outcome->EditValue = $this->client_met_outcome->Options(TRUE);

		// how_objective
		$this->how_objective->EditAttrs["class"] = "form-control";
		$this->how_objective->EditCustomAttributes = "";
		$this->how_objective->EditValue = $this->how_objective->CurrentValue;
		$this->how_objective->PlaceHolder = ew_RemoveHtml($this->how_objective->FldCaption());

		// case_notes
		$this->case_notes->EditAttrs["class"] = "form-control";
		$this->case_notes->EditCustomAttributes = "";
		$this->case_notes->EditValue = $this->case_notes->CurrentValue;
		$this->case_notes->PlaceHolder = ew_RemoveHtml($this->case_notes->FldCaption());

		// create_date
		$this->create_date->EditAttrs["class"] = "form-control";
		$this->create_date->EditCustomAttributes = "";
		$this->create_date->EditValue = ew_FormatDateTime($this->create_date->CurrentValue, 8);
		$this->create_date->PlaceHolder = ew_RemoveHtml($this->create_date->FldCaption());

		// update_date
		// updated_by

		$this->updated_by->EditAttrs["class"] = "form-control";
		$this->updated_by->EditCustomAttributes = "";
		$this->updated_by->EditValue = $this->updated_by->CurrentValue;
		$this->updated_by->PlaceHolder = ew_RemoveHtml($this->updated_by->FldCaption());

		// Call Row Rendered event
		$this->Row_Rendered();
	}

	// Aggregate list row values
	function AggregateListRowValues() {
	}

	// Aggregate list row (for rendering)
	function AggregateListRow() {

		// Call Row Rendered event
		$this->Row_Rendered();
	}
	var $ExportDoc;

	// Export data in HTML/CSV/Word/Excel/Email/PDF format
	function ExportDocument(&$Doc, &$Recordset, $StartRec, $StopRec, $ExportPageType = "") {
		if (!$Recordset || !$Doc)
			return;
		if (!$Doc->ExportCustom) {

			// Write header
			$Doc->ExportTableHeader();
			if ($Doc->Horizontal) { // Horizontal format, write header
				$Doc->BeginExportRow();
				if ($ExportPageType == "view") {
					if ($this->weeknumber->Exportable) $Doc->ExportCaption($this->weeknumber);
					if ($this->counselor->Exportable) $Doc->ExportCaption($this->counselor);
					if ($this->client->Exportable) $Doc->ExportCaption($this->client);
					if ($this->outcome_note->Exportable) $Doc->ExportCaption($this->outcome_note);
					if ($this->client_met_outcome->Exportable) $Doc->ExportCaption($this->client_met_outcome);
					if ($this->how_objective->Exportable) $Doc->ExportCaption($this->how_objective);
					if ($this->case_notes->Exportable) $Doc->ExportCaption($this->case_notes);
					if ($this->create_date->Exportable) $Doc->ExportCaption($this->create_date);
					if ($this->update_date->Exportable) $Doc->ExportCaption($this->update_date);
					if ($this->updated_by->Exportable) $Doc->ExportCaption($this->updated_by);
				} else {
					if ($this->weeknumber->Exportable) $Doc->ExportCaption($this->weeknumber);
					if ($this->counselor->Exportable) $Doc->ExportCaption($this->counselor);
					if ($this->client->Exportable) $Doc->ExportCaption($this->client);
					if ($this->outcome_note->Exportable) $Doc->ExportCaption($this->outcome_note);
					if ($this->client_met_outcome->Exportable) $Doc->ExportCaption($this->client_met_outcome);
					if ($this->case_notes->Exportable) $Doc->ExportCaption($this->case_notes);
				}
				$Doc->EndExportRow();
			}
		}

		// Move to first record
		$RecCnt = $StartRec - 1;
		if (!$Recordset->EOF) {
			$Recordset->MoveFirst();
			if ($StartRec > 1)
				$Recordset->Move($StartRec - 1);
		}
		while (!$Recordset->EOF && $RecCnt < $StopRec) {
			$RecCnt++;
			if (intval($RecCnt) >= intval($StartRec)) {
				$RowCnt = intval($RecCnt) - intval($StartRec) + 1;

				// Page break
				if ($this->ExportPageBreakCount > 0) {
					if ($RowCnt > 1 && ($RowCnt - 1) % $this->ExportPageBreakCount == 0)
						$Doc->ExportPageBreak();
				}
				$this->LoadListRowValues($Recordset);

				// Render row
				$this->RowType = EW_ROWTYPE_VIEW; // Render view
				$this->ResetAttrs();
				$this->RenderListRow();
				if (!$Doc->ExportCustom) {
					$Doc->BeginExportRow($RowCnt); // Allow CSS styles if enabled
					if ($ExportPageType == "view") {
						if ($this->weeknumber->Exportable) $Doc->ExportField($this->weeknumber);
						if ($this->counselor->Exportable) $Doc->ExportField($this->counselor);
						if ($this->client->Exportable) $Doc->ExportField($this->client);
						if ($this->outcome_note->Exportable) $Doc->ExportField($this->outcome_note);
						if ($this->client_met_outcome->Exportable) $Doc->ExportField($this->client_met_outcome);
						if ($this->how_objective->Exportable) $Doc->ExportField($this->how_objective);
						if ($this->case_notes->Exportable) $Doc->ExportField($this->case_notes);
						if ($this->create_date->Exportable) $Doc->ExportField($this->create_date);
						if ($this->update_date->Exportable) $Doc->ExportField($this->update_date);
						if ($this->updated_by->Exportable) $Doc->ExportField($this->updated_by);
					} else {
						if ($this->weeknumber->Exportable) $Doc->ExportField($this->weeknumber);
						if ($this->counselor->Exportable) $Doc->ExportField($this->counselor);
						if ($this->client->Exportable) $Doc->ExportField($this->client);
						if ($this->outcome_note->Exportable) $Doc->ExportField($this->outcome_note);
						if ($this->client_met_outcome->Exportable) $Doc->ExportField($this->client_met_outcome);
						if ($this->case_notes->Exportable) $Doc->ExportField($this->case_notes);
					}
					$Doc->EndExportRow();
				}
			}

			// Call Row Export server event
			if ($Doc->ExportCustom)
				$this->Row_Export($Recordset->fields);
			$Recordset->MoveNext();
		}
		if (!$Doc->ExportCustom) {
			$Doc->ExportTableFooter();
		}
	}

	// Add User ID filter
	function AddUserIDFilter($sFilter) {
		global $Security;
		$sFilterWrk = "";
		$id = (CurrentPageID() == "list") ? $this->CurrentAction : CurrentPageID();
		if (!$this->UserIDAllow($id) && !$Security->IsAdmin()) {
			$sFilterWrk = $Security->UserIDList();
			if ($sFilterWrk <> "")
				$sFilterWrk = '`dbkey_counselor` IN (' . $sFilterWrk . ')';
		}

		// Call User ID Filtering event
		$this->UserID_Filtering($sFilterWrk);
		ew_AddFilter($sFilter, $sFilterWrk);
		return $sFilter;
	}

	// User ID subquery
	function GetUserIDSubquery(&$fld, &$masterfld) {
		global $UserTableConn;
		$sWrk = "";
		$sSql = "SELECT " . $masterfld->FldExpression . " FROM `case_notes`";
		$sFilter = $this->AddUserIDFilter("");
		if ($sFilter <> "") $sSql .= " WHERE " . $sFilter;

		// Use subquery
		if (EW_USE_SUBQUERY_FOR_MASTER_USER_ID) {
			$sWrk = $sSql;
		} else {

			// List all values
			if ($rs = $UserTableConn->Execute($sSql)) {
				while (!$rs->EOF) {
					if ($sWrk <> "") $sWrk .= ",";
					$sWrk .= ew_QuotedValue($rs->fields[0], $masterfld->FldDataType, EW_USER_TABLE_DBID);
					$rs->MoveNext();
				}
				$rs->Close();
			}
		}
		if ($sWrk <> "") {
			$sWrk = $fld->FldExpression . " IN (" . $sWrk . ")";
		}
		return $sWrk;
	}

	// Get auto fill value
	function GetAutoFill($id, $val) {
		$rsarr = array();
		$rowcnt = 0;

		// Output
		if (is_array($rsarr) && $rowcnt > 0) {
			$fldcnt = count($rsarr[0]);
			for ($i = 0; $i < $rowcnt; $i++) {
				for ($j = 0; $j < $fldcnt; $j++) {
					$str = strval($rsarr[$i][$j]);
					$str = ew_ConvertToUtf8($str);
					if (isset($post["keepCRLF"])) {
						$str = str_replace(array("\r", "\n"), array("\\r", "\\n"), $str);
					} else {
						$str = str_replace(array("\r", "\n"), array(" ", " "), $str);
					}
					$rsarr[$i][$j] = $str;
				}
			}
			return ew_ArrayToJson($rsarr);
		} else {
			return FALSE;
		}
	}

	// Table level events
	// Recordset Selecting event
	function Recordset_Selecting(&$filter) {

		// Enter your code here	
	}

	// Recordset Selected event
	function Recordset_Selected(&$rs) {

		//echo "Recordset Selected";
	}

	// Recordset Search Validated event
	function Recordset_SearchValidated() {

		// Example:
		//$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value

	}

	// Recordset Searching event
	function Recordset_Searching(&$filter) {

		// Enter your code here	
	}

	// Row_Selecting event
	function Row_Selecting(&$filter) {

		// Enter your code here	
	}

	// Row Selected event
	function Row_Selected(&$rs) {

		//echo "Row Selected";
	}

	// Row Inserting event
	function Row_Inserting($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE
		// Default to user and current time

		$this->updated_by->DbValue = CurrentUserID();
		$this->updated_on->DbValue = date('Y-m-d H:m:s');
		$sql = "select trim(outcome_note) from client_outcome where client_outcome.dbkey_client = " . $this->dbkey_client->CurrentValue;
		$rsnew['outcome_note'] = ew_ExecuteScalar($sql);
		$rsnew['updated_by'] = $this->dbkey_counselor->CurrentValue;
		return TRUE;
	}

	// Row Inserted event
	function Row_Inserted($rsold, &$rsnew) {

		//echo "Row Inserted"
	}

	// Row Updating event
	function Row_Updating($rsold, &$rsnew) {

		// Enter your code here
		// To cancel, set return value to FALSE
		// Default to user and current time

		$this->updated_by->DbValue = CurrentUserID();
		$this->updated_on->DbValue = date('Y-m-d H:m:s');
		$rsnew['updated_by'] = $this->dbkey_counselor->CurrentValue;
		return TRUE;
	}

	// Row Updated event
	function Row_Updated($rsold, &$rsnew) {

		//echo "Row Updated";
	}

	// Row Update Conflict event
	function Row_UpdateConflict($rsold, &$rsnew) {

		// Enter your code here
		// To ignore conflict, set return value to FALSE

		return TRUE;
	}

	// Grid Inserting event
	function Grid_Inserting() {

		// Enter your code here
		// To reject grid insert, set return value to FALSE

		return TRUE;
	}

	// Grid Inserted event
	function Grid_Inserted($rsnew) {

		//echo "Grid Inserted";
	}

	// Grid Updating event
	function Grid_Updating($rsold) {

		// Enter your code here
		// To reject grid update, set return value to FALSE

		return TRUE;
	}

	// Grid Updated event
	function Grid_Updated($rsold, $rsnew) {

		//echo "Grid Updated";
	}

	// Row Deleting event
	function Row_Deleting(&$rs) {

		// Enter your code here
		// To cancel, set return value to False

		return TRUE;
	}

	// Row Deleted event
	function Row_Deleted(&$rs) {

		//echo "Row Deleted";
	}

	// Email Sending event
	function Email_Sending(&$Email, &$Args) {
		 return TRUE;
	}

	// Lookup Selecting event
	function Lookup_Selecting($fld, &$filter) {

		//var_dump($fld->FldName, $fld->LookupFilters, $filter); // Uncomment to view the filter
		// Enter your code here

	}

	// Row Rendering event
	function Row_Rendering() {

		// Enter your code here	
	}

	// Row Rendered event
	function Row_Rendered() {

		// To view properties of field class, use:
		//var_dump($this-><FieldName>); 

	}

	// User ID Filtering event
	function UserID_Filtering(&$filter) {

		// Enter your code here
	}
}
?>
