<?php
class access {
	// Function: _set_path
	// Description: set path so we know the current path incase we need to exclude authority.
	// Input: 
	// 			path - valid path name  
	//			
	// Output:
	//			True 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	function _set_path($path) {
		$this->path = $path;
		return true;
	}
	
	// Function: _folder_access
	// Description: based on path sent in check to see the existing path contains allowed path. Also any subfolders.
	// Input: 
	// 			path - set_path class must have been called. 
	//			
	// Output:
	//			True if path exists.
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	function _folder_access() {
		$string = "documentsXtechnicianXQuotations";		
		$folder = new folder();
		$path_key = $folder->_build_path_key($this->path);
		if (strstr($path_key,$string)) return true; else return false;
	}
	
	// Function: _access_allowed
	// Description: Based on access-type check to see if user has access to this function.
	// Input: 
	// 			access_type - Type to determine what to check for authority requirements. 
	//			
	// Output:
	//			True if user has access else false. 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	function _access_allowed($access_type) {
			$admin = new user();
			$data = $admin->_load_info();
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			if ($admin->_is_active_login())
			{
				$sql = "SELECT\n"
				 . " *\n"
				 . "FROM\n"
				 . " `" . $_SESSION[FILE_PREFIX] . "access_type`,`" . $_SESSION[FILE_PREFIX] . "privileges`,`" . $_SESSION[FILE_PREFIX] . "site_admin` where "
				 . " `" . $_SESSION[FILE_PREFIX] . "access_type`.`access_type` = `" . $_SESSION[FILE_PREFIX] . "privileges`.`" ."access_type_dbkey`"
				 . " and "
				 . " `" . $_SESSION[FILE_PREFIX] . "site_admin`.`auth_status` = `" . $_SESSION[FILE_PREFIX] . "privileges`.`auth_status` AND `" . $_SESSION[FILE_PREFIX] . "access_type`.`access_type` ='". $access_type . "'
				 and `" . $_SESSION[FILE_PREFIX] . "site_admin`.dbkey = " . (int) $data[dbkey] ;
				 
					
						
					if ($db->_query($sql)) {
						if ($data=$db->_fetch()) return true; else return false;
					}
					else return false;
			}
			else 
				return false;
			
	}
	
	function _access_allowed_auth_status($access_type,$auth_status) {
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			//echo "<h1> $access_type,$auth_status </h1>";
	
	$sql = "SELECT\n"
     . " *\n"
     . "FROM\n"
     . " `" . $_SESSION[FILE_PREFIX] . "access_type`,`" . $_SESSION[FILE_PREFIX] . "privileges` where "
     . " `" . $_SESSION[FILE_PREFIX] . "access_type`.`access_type` = `" . $_SESSION[FILE_PREFIX] . "privileges`.`access_type_dbkey`"
     . " and "
     . " `" . $_SESSION[FILE_PREFIX] . "privileges`.`auth_status` = '". $auth_status . "' AND `" . $_SESSION[FILE_PREFIX] . "access_type`.`access_type` ='". $access_type . "'";
			//new debug(true,$sql);
		if ($db->_query($sql)) {
			if ($data=$db->_fetch()) return true; else return false;
		}
		else return false;
	}
	
	function _add_privileges($access_type,$auth_status) {
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			//echo "<h1> $access_type,$auth_status </h1>";
	
	$sql = "SELECT * from `vss_privileges` where `access_type_dbkey` = '" . $access_type . "' and `auth_status` = '" . $auth_status . "'"; 
			
		if ($db->_query($sql)) {
				if (!$data=$db->_fetch())
					$sql = "insert into `vss_privileges` set `access_type_dbkey` = '" . $access_type . "', `auth_status` = '" . $auth_status . "'"; 
					$db->_query($sql);
					//new debug(true, $sql);
					return true;		
		}
		else 
		return false;
	}
	
	function _delete_privileges($access_type,$auth_status) {
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			//echo "<h1> $access_type,$auth_status </h1>";
			$sql = "delete from `vss_privileges` where `access_type_dbkey` = '" . $access_type . "' and `auth_status` = '" . $auth_status . "'"; 	
			$db->_query($sql);
			return true;		
	}
	
	
	function _add_auth_status($auth_status, $auth_description) {
			$error = array();
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			
			// Verify no active users are using this group.
			$sql = "SELECT * from `vss_tables_data` where `dbkey_tables` = 'auth' and (`dbkey` = '" . $auth_status . "' or `description` = '" . $auth_description . "')";
			if ($db->_query($sql))  
				if ($data=$db->_fetch())
				{
						$error2 .= "Group " . $auth_status .  " or group code description " . $auth_description . " already exists. Please choose a code and description that does not exist.</br> ";
				}
			if ($auth_status == '') $error2 .= "Invalid group code entered.</br> ";
			if ($auth_description == '') $error2 .= "Invalid Group Name entered.</br> ";
					
			if($error2){
				$error['auth_status'] = $error2;
			}
			else 
			{
				//echo "<h1> $access_type,$auth_status </h1>";
				$sql = "insert into `vss_tables_data` set `dbkey_tables` = 'auth', dbkey = '" . $auth_status . "', `description` = '" . $auth_description . "'"; 
					
				$db->_query($sql);
			}
			return $error;
	}
	
	function _delete_auth_status($auth_status) {
			$error = array();
			
			// check access type and validate this user has access to it. Return true or false based on that. 
			$db = new database();
			$db->_connect();
			
			// Verify no active users are using this group.
			$sql = "SELECT * from `vss_site_admin` where `status` = 'A' and `auth_status` = '" . $auth_status . "'"; 
			
			if ($db->_query($sql))  
				if ($data=$db->_fetch())
						$error2 .= "You currently have active users assigned to group Code " . $auth_status . ". Please update the User status to inactive and try this action again. </br> ";
		
		
			if($error2){
				$error['auth_status'] = $error2;
			}
			
			else
			 {
				//echo "<h1> $access_type,$auth_status </h1>";
				$sql = "delete from `vss_tables_data` where `dbkey_tables` = 'auth' and dbkey = '" . $auth_status . "'"; 	
				
				$db->_query($sql);
			 }
			return $error;		
	}
	
	//------------------------------------
	// Return information 
	//------------------------------------
	function _return_all_privileges() {
		$db = new database();
		$db->_connect();
		$index = 0;
		$sql = "SELECT `description`,`access_type` FROM `" . $_SESSION[FILE_PREFIX] . "access_type` ";
		//echo "<h1>Made IT $sql</h1>";
		if ($db->_query($sql)) {
				while ($data=$db->_fetch()) {
					$all_users[$index +=1] = $data;
				}
				return $all_users;
			}
		return FALSE;
	}
	
	//------------------------------------
	// Return information 
	//------------------------------------
	function _return_all_auth_status() {
		$db = new database();
		$db->_connect();
		$index = 0;
		$sql = "SELECT `dbkey`,`description` FROM `" . $_SESSION[FILE_PREFIX] . "tables_data` WHERE `dbkey_tables` = 'auth'";
		//echo "<h1>Made IT $sql</h1>";
		if ($db->_query($sql)) {
				while ($data=$db->_fetch()) {
					$all_users[$index +=1] = $data;
				}
				return $all_users;
			}
		return FALSE;
	}
	
	
}
?>