<?php
//******************************************************************************************
	// File and Folder Access Clas: Determines access based on login type and other rules. 
	//******************************************************************************************


	
	
/******************************************************************************/
/** Class: Folder                                                           ***/
/** Description: The folder class is used to navigate thorugh document      ***/
/**              management folder and files.                               ***/
/******************************************************************************/	
class folder  {
	var $file_list = array();
	var $previous_path;
	var $current_path;
	var $index = 0;
	var $all_files_array = array();
	var $all_paths_array = array();
	var $full_file = array();
	var $base_path;
	
	function folder($path){
		
		$search = trim(" / ");
		$this->base_path = trim("documents/docs_pub/ ");
		$this->base_path = str_replace($search,  DIRECTORY_SEPARATOR, $this->base_path);
		$_SESSION[BASE_PATH] = $this->base_path;
		
		$db = new database();
		$db->_connect();
		if ((trim($path) == 'base') or (!is_dir(urldecode($path))) or (strpos($path,"docs_pub") == 0) or (strpos($path,"docs_pub") == FALSE) ) { 
			$path = realpath($_SESSION[BASE_PATH]);
			//echo "$path";
		// Set Paths
			$this->current_path = $path;
			$this->previous_path = "";
		}
		else
		{
			// Set Paths
			$this->current_path = $path;
			$this->previous_path = $this->_get_previous_path();
		}

		}
		
	
	
	
	//******************************************************************************************
	// FILE FUNCTIONS: All File related functions go here.
	//******************************************************************************************
	
	
	// Function: _found_file 
	// Description: Check to see if a directory has atleast one file in it. Used to help determine if user can delete this directory as a requirement is no files can exist.   
	// Input: 
	//			folder path - full path including root. 
	// Output:
	//			True if atleast one file exists else false.
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	// 
	function _found_file($path) {
		$path = $this->current_path;
		foreach (new DirectoryIterator($path) as $file) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
			if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && ($file->isfile()) ) {
				return true;
				break; 
			}
		}	
		return false;
	}
	
	// Function: _build_files
	// Description: given a full path load all folders and files into an array.
	// Input: 
	//			folder path - full path including root. 
	// Output:
	//			Builds a table with files and links to allow them to be downloaded. 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	// 
	// 
	function _build_files() {
		$path = $this->current_path;
		$path = urldecode($path);	
		
		$path_array = array();
		foreach (new DirectoryIterator($path) as $file) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
			if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && ($file->isFile()) && ($file->getFilename() != "_notes")  ) {
				$path_array[$file->getFilename()] = $file->getPathname();
			}
		}	
		
		// Sort Array by name
		natcasesort($path_array);
		
		// Echo out the file to the page. This could be pulled out and sent to calling page. 
		?> <?php
		return $path_array;
		
		?> <?php
	}
		
	
	// Function: _build_files_option
	// Description:  list all files and build a drop down list to choose from. Used to select a file for deletion. 
	// Input: 
	//			folder path - full path including root. 
	// Output:
	//			builds a option list of files. 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	// 
	function _build_files_option($path) {
		
		$path_array = array();
		foreach (new DirectoryIterator($path) as $file) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
			if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && ($file->isFile()) && ($file->getFilename() != "_notes")  ) {
				$path_array[$file->getFilename()] = realpath($file->getPathname());
			}
		}
		// Sort Array by name
		natcasesort($path_array);
		
		// Spin through array and call recursively. 
		foreach ($path_array as $file_name => $file_path) {
			
				?><option value="<?php echo $file_name; ?>"><?php echo $file_name; ?></option><?php 
		}
				
	}
	
	
	
	
	//******************************************************************************************
	// Folder FUNCTIONS: All folder and path related functions go here.
	//******************************************************************************************
	
	
	// Function: _get_formated_path
	// Description: returns a formated version of the path that will exclude the root informaiton. 
	// 				Typically only used to echo out information to the user in a more feindly formate.  
	// Input: 
	// 			start characters - sting of charcters in the path we want to find and ignore anything behind it 
	//			(i.e full path c:/root/bla/bla/document/technician/myfolder. We may pass in bla/bla/documents/technician in this input.
	//			length  = Identifies how many charcters to jump forward. This combined with the start char will determine what peices to extract out of the path. 
	// 			(Might not have 	needed this, may be able to use lenght function against the first input instead. Oh well.
	//			folder path - full path including root. Based off the first two input values this will be substringed to generate the formated path.  
	// Output:
	//			Formated path name
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	function _get_formated_path($start ,$length, $folder_path) {
		$pos = stripos(trim($folder_path),$start);
		//echo "pos $pos start $start folder $folder_path";
		if ($pos <> 0) $pos = $pos + 	strlen(trim($start)) + (int)$length + 1;
		return substr($folder_path,$pos);	
	}
	

	// Function: htmlpath  - REMOVE if not USED. 
	// Description: Builds a path designed for html. I pulled this from another site. I do not believe I am using this any longer. 
	// Input: 
	//			folder path - full path including root. Must be accurate as it is used to key to the folder datbase file.   
	// Output:
	//			path minus root. 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	function htmlpath($relative_path) {
    	$realpath=realpath($relative_path);
    	$htmlpath=str_replace($_SERVER['DOCUMENT_ROOT'],'',$realpath);
    	return $htmlpath;
	}

	
		
	// Function: _build_folder 
	// Description: Given a starting path it will recursively run through all subdirectories and build a menu lising all folders.
	// Input: 
	//			folder path - full path including root. This is the Starting folder.    
	// Output:
	//			builds a UL/LI list of all subfolders.  
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	function _load_all_file($path) {
		
		// Run through all files in this path and load to array.
		$this->_load_files($path);
		
		// Build array of folders. 
		$path_array = array();
		$path_array_numeric = array();
		foreach (new DirectoryIterator($path) as $file) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
			
			if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && ($file->isDir()) ) {
				$name = realpath($file->getPathname());
				$file_name_sort = $file->getFilename();
				
				
				if (is_numeric(trim($file_name_sort))) $path_array_numeric[$file_name_sort] = $name;
				else $path_array[$file_name_sort] = $name;
			}
			
		}
		// Sort Array by name
		natcasesort($path_array);
		natcasesort($path_array_numeric);
		// Reverse array
		//$path_array = array_reverse($path_array, true);
		$path_array_numeric = array_reverse($path_array_numeric, true);
		//$path_array_numeric = array_sort/($path_array, true);
		$path_array = $path_array_numeric + $path_array;
		// Spin through array and call recursively. 
		foreach ($path_array as $key => $path_value) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
								
				$file_path = $path_value;
				$file_name = $key;
				
				if ($this->_found_dir($file_path)) {	
					$files_a = $this->_load_files($file_path);
					if (count($files_a)) {
						foreach ($files_a as $skey => $spath) {
							$this->full_file[$this->_get_sub_folder_name($file_path)][$skey] = $file_path;
						}
					}
					$this->_load_all_file($file_path);										  
					
				} 
				// $this->full_file[$path_value][$file_name] = 'anything';
				
		}
				
	}

	function _display_list_format($path) {
		
		// Run through all files in this path and load to array.
		$this->_load_files($path);
		
		// Build array of folders. 
		$path_array = array();
		$path_array_numeric = array();
		foreach (new DirectoryIterator($path) as $file) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
			
			if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && ($file->isDir()) ) {
				$name = realpath($file->getPathname());
				$file_name_sort = $file->getFilename();
				
				
				if (is_numeric(trim($file_name_sort))) $path_array_numeric[$file_name_sort] = $name;
				else $path_array[$file_name_sort] = $name;
			}
			
		}
		// Sort Array by name
		natcasesort($path_array);
		natcasesort($path_array_numeric);
		// Reverse array
		//$path_array = array_reverse($path_array, true);
		$path_array_numeric = array_reverse($path_array_numeric, true);
		//$path_array_numeric = array_sort/($path_array, true);
		$path_array = $path_array_numeric + $path_array;
		// Spin through array and call recursively. 
		foreach ($path_array as $key => $path_value) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
								
				$file_path = $path_value;
				$file_name = $key;
				  //  echo "<h1>file path is: $file_path had a pass value of " . $this->_found_dir($file_path) . " </br></h1>";
				if ($this->_found_dir($file_path)) {
						
					$files_a = $this->_load_files($file_path);
					?> 
                        <li><input type="checkbox" name"nothing" id="<?php echo basename($file_path); ?>" /><label for="<?php echo basename($file_path); ?>"><?php echo basename($file_path); ?></label>
                        <ul>

                    <?php
					if (count($files_a)) {
						
						foreach ($files_a as $skey => $spath) {
							
							?><li> 	<input type="checkbox" name='checkboxselect[]' value="<?php echo $file_path . DIRECTORY_SEPARATOR . $skey;?>"  />
                            		<input type="hidden" name="select_file_path[]"  value = "<?php echo $file_path; ?>"/>
                                    <input type="hidden" name="select_file_file[]" value = "<?php echo $skey; ?>"/>
                                 
                            
                            <a  style = "color:white;" href='control.php?path= <?php echo urlencode($file_path . DIRECTORY_SEPARATOR . $skey);?>'> <?php echo $skey; ?></a></li> <?php
							$this->full_file[$this->_get_sub_folder_name($file_path)][$skey] = $file_path;
						}
						
					}
					$this->_display_list_format($file_path);										  
					?> </ul> <?php 
				} 
				// $this->full_file[$path_value][$file_name] = 'anything';
				
		}
				
	}

	
		// Function: _load_files
	// Description: loads all files in a path to array including the path
	 
	function _load_files($path) {
		$path = urldecode($path);	
		$path_array = array();
		
		// Only process if path is not already there. 
		if (in_array($path , $this->all_paths_array) == FALSE)
		{
			foreach (new DirectoryIterator($path) as $file) {
				//if the file is not this file, and does not start with a '.' or '..',then store it for later display
				if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && ($file->isFile()) && ($file->getFilename() != "_notes")  ) {
					$path_array[$file->getFilename()] = $file->getPathname();
					$ful_path = $path . trim(" \ ") . $file->getFilename();
					$this->all_files_array[$ful_path] = $file->getFilename();
					$this->all_paths_array[$ful_path] = $path;
					$this->index += 1; 
					
				}
			}	
		}
		
		// Sort Array by name
		natcasesort($path_array);
		return $path_array;
	}
	
	
		// Function: _found_dir
	// Description: Check to see if a directory has atleast one dir in it. Used to help determine if user can delete this directory as a requirement is no subdirectories.  
	// Input: 
	//			folder path - full path including root. 
	// Output:
	//			True if atleast one directory exists else false.
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	// 
	function _found_dir($path) {
		if (is_dir($path))
		{ return true; }
		else 
		return false;
	}
	

	
	function _get_previous_path()
	{ 	
		$path = $this->current_path;
		
		$offset = -1;
		// This will check windows formating. Geese!! 
		$search = "\ ";
		$pos = strrpos ($path , trim($search) , $offset);
		// This will check unix formating.  Geese!!
		if ($pos == NULL or $pos == 0 or $pos == FALSE)
		{
			$search = "/ ";
			$pos = strrpos ($path , trim($search) , $offset);
		}
		return  substr($path, 0, $pos);
	}
	
	function _get_folder_name() {
		if (trim($this->previous_path) == '') return "";
		else return $this->folder_name = basename($this->current_path);
	}
	
	function _get_sub_folder_name($path) {
		
		$pos = strpos($path, $this->base_path);
		if ($pos == NULL or $pos == 0 or $pos == FALSE)
		{	$to  = "\ ";
			$from  = " /";
			//echo " alkjlkjlkj is: " . str_replace(trim($from), trim($to),$this->base_path);
			$pos = strrpos ($path ,  str_replace(trim($from), trim($to),$this->base_path));
		}
		$actual = strlen($this->base_path) + $pos;
		return substr($path,$actual);
	}
	
	// Function: _build_folder 
	// Description: Given a starting path it will recursively run through all subdirectories and build a menu lising all folders.
	// Input: 
	//			folder path - full path including root. This is the Starting folder.    
	// Output:
	//			builds a UL/LI list of all subfolders.  
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//
	function _build_folders_list() {
		$path = $this->current_path;
		// Build array of folders. 
		$path_array = array();
		$path_array_numeric = array();
		foreach (new DirectoryIterator($path) as $file) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
			if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && ($file->isDir()) ) {
				$name = realpath($file->getPathname());
				$file_name_sort = $file->getFilename();
				if (is_numeric(trim($file_name_sort))) $path_array_numeric[$file_name_sort] = $name;
				else $path_array[$file_name_sort] = $name;
			}
		}
		// Sort Array by name
		natcasesort($path_array);
		natcasesort($path_array_numeric);
		// Reverse array
		//$path_array = array_reverse($path_array, true);
		$path_array_numeric = array_reverse($path_array_numeric, true);
		//$path_array_numeric = array_sort($path_array, true);
		$path_array = $path_array_numeric + $path_array;
		// Spin through array and call recursively. 
		
		return $path_array;
		
		
				
	}
	

	
	
	// Function: _found_objects
	// Description: Check to see if a directory or file exists
	// Input: 
	//			folder path - full path including root. 
	// Output:
	//			true if any objects found in path else false. 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//  
	function _found_objects() {
		$path = $this->current_path;
		foreach (new DirectoryIterator($path) as $file) {
			//if the file is not this file, and does not start with a '.' or '..',then store it for later display
			if ( (!$file->isDot()) && ($file->getFilename() != basename($_SERVER['PHP_SELF'])) && (($file->isDir()) or ($file->isFile()))) {
				return true;
			}
		}	
		return false;
	}
	
	
	// Function: _delete_dir
	// Description: delete a direcotory given valid path. 
	// Input: 
	//			folder path - full path including root. 
	// Output:
	//			true if dir is deleted else false. 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//   
	function _delete_dir() {
		$path = $this->current_path;
		//Make sure this is a directory	and their are no files or directories in this directory.
		$string = "documentsXdocs_pubX";
		$path_key = $this->_build_path_key($path);
		if ( (is_dir($path)) and (!$this->_found_objects()) and (strstr($path_key,$string)) ) {
					// Ok remove 
					
					$folder_path = $this->_get_formated_path('documents',11,$path);
					//Remove this path even if there are files. We already checked for necessary files. 
					$this->rrmdir($path);
					return true;		
		}
		else {	
			return false;
		}
	}
	
	
	// Function: _add_dir
	// Description: add a direcotory given valid path. 
	// Input: 
	//			folder path - full path including root. 
	// Output:
	//			true if dir is added else false. 
	// Created By: Jesse Schaaf on: 07/15/2011
	// Change Log:
	//  Date	Pgmr			Description of Change
	//    
	function _add_dir($path,$name) {
		//Name must be alpha numeric. 
		if (!preg_match("/^[a-zA-Z0-9_& ]+$/i", $name) ) return false;
		
		if ( (!is_dir($path))) {
					// Ok remove 
					// make the directory.
					if (mkdir($path)) {
						return true;
					} else return false;
		}
	
}

// Function:_build_path_key
// Description: given a path create addunique key to search the folder database with. 
// Input: 
//			folder path - full path including root. 
// Output:
//			unique key 
// Created By: Jesse Schaaf on: 07/15/2011
// NOTE:  !!!!!!!! HEY LOOK HERE!!!!!! DO NOT, I REPEAT DO NOT CHANGE THIS CODDE WITHOUT SERIOUS CONSIDERATION. This will change the key look up to the folder file and links to the file wll no longer work!!
// Change Log:
//  Date	Pgmr			Description of Change
//  
function _build_path_key ($path) {
			$replace = trim('/ '); 
			$with = 'X'; 
			$path_key = str_replace($replace,$with, trim($path));
			$replace = trim('\ '); 
			$with = 'X'; 
			$path_key = str_replace($replace,$with, trim($path_key));
			$replace = trim(' '); 
			$with = '_'; 
			$path_key = str_replace($replace,$with, trim($path_key));
			return trim($path_key);
}

// Function: rrmdir
// Description: removes directory. Supporting function for others above. 
// Input: 
//			folder path - full path including root. 
// Output:
//			true if dir is added else false. 
// Created By: Jesse Schaaf on: 07/15/2011
// Change Log:
//  Date	Pgmr			Description of Change
//    
function rrmdir($dir) { 

	switch ($_SERVER['SERVER_NAME']) {
							case "localhost":  
								$slash = trim("\ ");
							break;
							default:
								$slash = "/";
							break;
	}
   if (is_dir($dir)) { 
     $objects = scandir($dir); 
     foreach ($objects as $object) { 
       if ($object != "." && $object != "..") { 
         if (filetype($dir.$slash.$object) == "dir") rrmdir($dir.$slash.$object); else unlink($dir.$slash.$object); 
       } 
     } 
     reset($objects);
     return rmdir($dir); 
   } 
 } 
 
 
// Function: _delete_file
// Description: deletes a file from server and db file. 
// Input: 
//			folder path - full path including root. 
//   		file: valid file. 
// Output:
//			true if dir is added else false. 
// Created By: Jesse Schaaf on: 07/15/2011
// Change Log:
//  Date	Pgmr			Description of Change
//  
	function _delete_file($path, $file) {
		//Make sure this is a directory	and their are not files or directories in this directory.
		
		switch ($_SERVER['SERVER_NAME']) {
							case "localhost":  
								$full_path = trim($path . "\ ") . $file;
							break;
							default:
								$full_path = $path . "/" . $file;
							break;
						}
		
	
		
		  if (is_file($full_path)) {
			if (unlink($full_path)) {
				
				return true;
			}
			else { return false;}	
		}
		else  {return false;}
	}
	
	// 
	// returns file age based on current date and time
	//
	function _get_file_age($path_file) {
		
		
		$php_todays_date = date("Y-m-d H:i:s");
		$file_date = date (DATE_ATOM, filemtime($path_file));
		$minutes = round((strtotime($php_todays_date) - strtotime($file_date))/(60));
		// Remove anything < 10 minutes
		if 	($minutes >= 10) unlink($path_file);
	}
	
	function _clean_up_temp() {
		$search = trim(" / ");
		$path = trim("doctemp/ ");
		$path = str_replace($search,  DIRECTORY_SEPARATOR, $path);
		
		$files = $this->_load_files($path);
		foreach ($files as $key => $value)
		{
			$this->_get_file_age($value);
		}
	}
	
 
}
?>