<?php

// ***************************************************
// Upload a file
// ***************************************************
// @param  string  $field_name  - Name of the screen field that contains the file name to upload
// @param  string  $valid_ext   - List of valid extension values, seperated by commas
// @param  string  $path 				- Path file is to be uploaded to
// @param  string  $overwrite   - Overwrite an existing file (Y=Overwrite, ''=Don't overwrite)
// @param  integer $max_size    - Maximum file size (in bytes)
// @param  integer $max_height  - Maximum image height (in pixels)
// @param  integer $max_width   - Maximum image width (in pixels)
 
// @return string  $msg         - Result message text
function upload_file($field_name, $valid_ext, $path, $overwrite = '', $max_size = MAX_UPLOAD_SIZE, $max_height = 0, $max_width = 0) {

	$msg = NULL;
	$full_path = trim(trim($path) . "/ ");
	$folder = new folder();
	// Ensure that path exists
	//create_directory($full_path);
	// Check Entension
	$path_parts = pathinfo($_FILES[$field_name]['name']);

	//var_dump($_FILES); exit;	
	$extension = strtolower($path_parts['extension']);
	// Allow Paths
	$allowed_paths = explode(", ", $valid_ext);
	for($i = 0; $i < count($allowed_paths); $i++) {
		if ($allowed_paths[$i] == "$extension") {
			$ok = 'Y';
		}
	}
	$ok = "Y";
	
	if($ok <> "Y") {
		$msg = "There was an error uploading " .  basename( $_FILES[$field_name]['name']) . ", invalid extension $extension!";
		return $msg;
	}

	// Check height and width
	//list($width, $height, $type, $w) = getimagesize($_FILES[$field_name]['tmp_name']);
	//if ( ($max_width > 0) && ($max_height > 0) ) {
	//	if( ($width > $max_width) || ($height > $max_height) ) {
	//		$msg = "There was an error uploading ".basename( $_FILES[$field_name]['name']) . ", file height/width is too large!";
	//		return $msg;
	//	}
	//}
	
	// overrite existing file
	if ($overwrite_file) {
		if ($handle = opendir($full_path)) {
			while (false !== ($file = readdir($handle))) {
				if ($file !== "." && $file !== "..") { 
					unlink($full_path.$file); 
				}
			}
		}
		closedir($handle);
	}

	$_FILES[$field_name]['tmp_name'];
	$file_path = $full_path.$_FILES[$field_name]['name'];
	if (move_uploaded_file($_FILES[$field_name]['tmp_name'], $file_path)) {
		$msg = "The file ".  basename( $_FILES[$field_name]['name'])." has been uploaded";
		
		return true;
	} 
	else {
		$msg = "There was an error uploading " .  basename( $_FILES[$field_name]['name']) . ", please try again! ";
		return $msg;
	}	
	
}


/**
 * Description: Retrieve a list of files from a specific IFS location
 *
 * @param  string  $full_path  - Path in the IFS where the files are to be retrieved from
 * @param  string  $chkbox_names - Array name to give to file 'delete' checkboxes
 * @param  string  $doc_desc     - Label to place on first table row
 * 
 * @return *NONE
 */
function retrieve_files($path, $chkbox_names, $path_level = "") {
	
	$full_path = set_server_path().$path;

	if (isset($full_path)) {		
		if(is_dir($full_path)) {
			if ($handle = opendir($full_path)) {
				while (false !== ($file = readdir($handle))) {
					if ($file != "." && $file != "..") { 
						$file_name = parseXMLcoding($file);
						$ufile = rawurlencode($file);	
						$href = $full_path.$ufile; ?>
						<!-- Display document information -->
						<tr>
						<td><input type='checkbox' name='<?php echo "$chkbox_names"; ?>[<?php echo "$file_name"; ?>]' value='<?php echo "$file_name"; ?>'>
            <img style="height:40px; width= 40px" src="<?php echo $path_level."../../images".$path.$ufile;?>"/>
            <?php /*
						<a href='<?php echo "$href"; ?>' target='_blank'> <?php echo "$file"; ?></a>&nbsp;&nbsp;</td> 
						*/ ?>
						</tr> <?php
					}
				}
			closedir($handle);
			}
		}
	}
}

// ************************************************
// Description: Delete a list of files
// ************************************************
// @param  string $path - Path to where the files to be deleted are located
// @param  array $chkbox_names  - Name of the POST array containing file names to delete
function delete_selected_files($path, $chkbox_names, $compare_file) {
	$same_file = FALSE;
	$full_path = set_server_path().$path;
	if (count($_POST[$chkbox_names]) > 0) {
		foreach ($_POST[$chkbox_names] as $file_name) {
			if ($file_name == $compare_file) {
				$same_file = TRUE;
			}
			$file_path = $full_path.trim($file_name);
			unlink($file_path);
		}
	}
	unset($_POST[$chkbox_names]);
	return $same_file;
}

// ************************************************
// Description: Return a selected file from the list
// ************************************************
// @param  string $path - Path to where the files to be deleted are located
// @param  array $chkbox_names  - Name of the POST array containing file names to delete
function return_selected_files($path, $chkbox_names) {
	$full_path = set_server_path().$path;
	if (count($_POST[$chkbox_names]) > 0) {
		foreach ($_POST[$chkbox_names] as $file_name) {
			return $file_name;
			unset($_POST[$chkbox_names]);
		}
	}
	return NULL;
}


//*********************************************************
//* Supporting functions
//*********************************************************

//--> Parce XML string
function parseXMLcoding($string) {
	if ( strlen($string) == 0 ) {
		return $string;
	}
	
	$string = preg_split("//", $string, -1, PREG_SPLIT_NO_EMPTY);

	for ( $i = 0; $i < count($string); $i++ ) {
		$dec = ord($string[$i]);
		if ( $dec > 127 ) {
			$string[$i] = '&#' . $dec . ';';
		}
	}
	return implode('',$string);
} 

//--> Create a directory.
function create_directory($full_path) {
	$exp=explode("/",$full_path);
	$way='';
	foreach($exp as $n) {
		$way.=$n.'/';
		if(!file_exists($way)) {
			mkdir($way);
		}
	}
}

//--> set_server_path will set the base path for server
function set_server_path() {
	switch ($_SERVER['SERVER_NAME']) {
		case "localhost":
			return "C:/Users/ed/websites/fantasyhunting/images";
			break;
		case "www.schaafnet.com":
		case "schaafnet.com":	
			$server_path = $_SERVER["DOCUMENT_ROOT"]."/test/fantasyhunting/images";
			return $server_path;
			break;
		case "www.fantasyhunting.com":
		case "fantasyhunting.com":
		 	$server_path = $_SERVER["DOCUMENT_ROOT"]."/images";
			return $server_path;
			break;
		default:
			echo "Lost server directive: Contact site administrator";
			exit;
			break;
	}
}

?>